SHEBANG
# Copyright (C) @BABOLO 2008  Dec 18 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up-evd.m4,v 1.3 2009/07/21 15:53:37 babolo Exp $

JNTROSTUP(ipmi,-evd,ipmidnl
,dnl
# jailup ${inclass}${suffix} dir jailname jailaddr[ uid[ gid[ command[ devN]]]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# installed ports/sysutils/ipmitool useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
uid="${4:-77987}"
gid="${5:-77987}"
cmd="${6:-open}"
dev="${7:-0}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY()

${up_libexe} "${main_dir}/libexec" << EOF
    ld-elf.so.1
    ipmievd
EOF

echo "${main_dir}/libexec/ipmievd" | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	operator:*:5:ipmi
	nogroup:*:65533:
	nobody:*:65534:
	ipmi:*:${gid}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
	ipmi:*:${uid}:${gid}::0:0:IPMI:/dev/null/none:/dev/null/none
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    localtime
    master.passwd		mode=0600
    master.template		mode=0600
..
EOF

${up_adc} "${JAILUPRC}" <<- EOF
#${genclass}	${inclass}${suffix}	${jdir}	${jailsname}	${jailsaddr}	0	${uid}	${gid}	${cmd}	${dev}
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF

${up_adc} "${STARTUPDIR}/devfs" <<- EOF
	${jdir}	ipmi	${inclass}${suffix}
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
